<template>
  <div class="project-tab project-tab-overview">
    <TaskForm v-if="!sessionName" @start-session="startTimer" />
    <Stopwatch v-if="sessionName" v-bind:sessionName="sessionName" @save-session="saveTimer" />
    <Timesheets v-bind:tasks="tasks" />
  </div>
</template>

<script>
import Timesheets from "../widgets/Timesheets.vue";
import TaskForm from "../widgets/TaskForm.vue";
import Stopwatch from "../widgets/Stopwatch.vue";

export default {
  name: "Dashboard",
  components: {
    Timesheets,
    TaskForm,
    Stopwatch
  },
  data: function() {
    return {
      tasks: [],
      sessionName: null
    };
  },
  methods: {
    addTask: function(task) {
      this.tasks.push(task);
    },
    startTimer: function(sessionName) {
      this.sessionName = sessionName;
      this.$stpw.startTimer();
    },
    saveTimer: function(value) {
      this.sessionName = null;
      this.$caller
        .saveTimesheet(this.$route.params.projectId, JSON.stringify(value))
        .then(() => {
          this.status = "ok";
        })
        .catch(err => {
          this.status = "ko : " + err;
        });
    }
  }
};
</script>

<style>
</style>

